Loading...
Searching...
No Matches
BALL::VIEW::AtomBondModelBaseProcessor Class Reference
Visualisation » Model Processors

`#include <BALL/VIEW/MODELS/atomBondModelBaseProcessor.h>`

Inheritance diagram for BALL::VIEW::AtomBondModelBaseProcessor:

## Public Member Functions

Constructors and Destructors
| AtomBondModelBaseProcessor ()
| AtomBondModelBaseProcessor (const AtomBondModelBaseProcessor &baseProcessor)
virtual | ~AtomBondModelBaseProcessor ()
virtual void | clear ()
Assignment
void | set (const AtomBondModelBaseProcessor &processor)
const AtomBondModelBaseProcessor & | operator= (const AtomBondModelBaseProcessor &processor)
Processor specific methods
virtual Processor::Result | operator() (Composite &composite)
debuggers and diagnostics
virtual void | dump (std::ostream &s=std::cout, Size depth=0) const
virtual void | clearComposites ()
virtual bool | createGeometricObjects ()
Public Member Functions inherited from BALL::VIEW::ModelProcessor
| ModelProcessor ()
| ModelProcessor (const ModelProcessor &model_processor)
virtual | ~ModelProcessor ()
virtual bool | isValid () const
GeometricObjectList & | getGeometricObjects ()
| Return the list with the created geometric objects.
const GeometricObjectList & | getGeometricObjects () const
| Return the list with the created geometric objects.
void | setDrawingPrecision (Index precision)
Index | getDrawingPrecision () const
void | setSurfaceDrawingPrecision (float precision)
float | getSurfaceDrawingPrecision () const
Public Member Functions inherited from BALL::UnaryProcessor< Composite >
| UnaryProcessor ()
| UnaryProcessor (const UnaryProcessor &)
virtual | ~UnaryProcessor ()
virtual bool | start ()
virtual bool | finish ()
Public Member Functions inherited from BALL::PropertyManager
BALL_INLINE | PropertyManager ()
| Default constructor.
BALL_INLINE | PropertyManager (const PropertyManager &property_manager)
| Copy constructor.
virtual | ~PropertyManager ()
| Destructor.
virtual void | destroy ()
| Clears all properties.
void | set (const PropertyManager &property_manager)
const PropertyManager & | operator= (const PropertyManager &property_manager)
void | get (PropertyManager &property_manager) const
void | swap (PropertyManager &property_manager)
BitVector & | getBitVector ()
const BitVector & | getBitVector () const
| operator BitVector & ()
void | setProperty (Property property)
void | clearProperty (Property property)
void | toggleProperty (Property property)
Size | countProperties () const
const NamedProperty & | getNamedProperty (Position index) const
NamedProperty & | getNamedProperty (Position index)
void | setProperty (const NamedProperty &property)
void | setProperty (const std::string &name)
void | setProperty (const std::string &name, bool value)
void | setProperty (const std::string &name, int value)
void | setProperty (const std::string &name, unsigned int value)
void | setProperty (const std::string &name, float value)
void | setProperty (const std::string &name, double value)
void | setProperty (const std::string &name, const std::string &value)
void | setProperty (const std::string &name, const PersistentObject &value)
const NamedProperty & | getProperty (const std::string &name) const
NamedPropertyIterator | beginNamedProperty ()
NamedPropertyIterator | endNamedProperty ()
void | clearProperty (const std::string &name)
Size | countNamedProperties () const
bool | hasProperty (Property property) const
| Query for an unnamed property.
bool | hasProperty (const std::string &name) const
| Query for a named property.
bool | operator== (const PropertyManager &pm) const
bool | operator!= (const PropertyManager &pm) const
| Inequality operator.
void | write (PersistenceManager &pm) const
| Persistent stream writing.
bool | read (PersistenceManager &pm)
| Persistent stream reading.
bool | isValid () const
void | dump (std::ostream &s=std::cout, Size depth=0) const

## Protected members

This methods are provided for easy generation of models. With the method insertAtom_() all Atom objects that will be part of the newly created model will be stored. This stored atoms are later used (in the method buildBondModels_()) to create the models of the Bond objects that can be reached from the atoms. The other methods are access method for the stored atoms.
vector< vector< Atom * > > | rings_
HashSet< const Atom * > | ring_atoms_
void | insertAtom_ (const Atom *atom)
void | clearUsedAtoms_ ()
std::list< const Atom * > & | getAtomList_ ()
HashSet< const Atom * > & | getAtomSet_ ()
void | buildBondModels_ ()
virtual void | visualiseBond_ (const Bond &bond)
virtual void | visualiseRings_ ()

## Additional Inherited Members

Public Types inherited from BALL::UnaryFunctor< ArgumentType, ResultType >
typedef ResultType | result_type
typedef ArgumentType | argument_type
typedef ArgumentType & | argument_reference
typedef const ArgumentType & | const_argument_reference
typedef ArgumentType * | argument_pointer
typedef const ArgumentType * | const_argument_pointer
Protected Attributes inherited from BALL::VIEW::ModelProcessor
GeometricObjectList | geometric_objects_
Index | drawing_precision_
float | surface_drawing_precision_

## Detailed Description

AtomBondModelBaseProcessor class. The class AtomBondModelBaseProcessor is the base class for all models whose structure is somewhat orientated after the Atom and Bond structure (e.g. the model Ball And Stick)

Definition at line 31 of file atomBondModelBaseProcessor.h.

## Constructor & Destructor Documentation

## AtomBondModelBaseProcessor() [1/2]

BALL::VIEW::AtomBondModelBaseProcessor::AtomBondModelBaseProcessor | ( |  | ) |

Default Constructor. Clear all used Atom objects.

## AtomBondModelBaseProcessor() [2/2]

BALL::VIEW::AtomBondModelBaseProcessor::AtomBondModelBaseProcessor | ( | const AtomBondModelBaseProcessor & | baseProcessor | ) |

Copy constructor.

## ~AtomBondModelBaseProcessor()

virtual BALL::VIEW::AtomBondModelBaseProcessor::~AtomBondModelBaseProcessor | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## buildBondModels_()

void BALL::VIEW::AtomBondModelBaseProcessor::buildBondModels_ | ( |  | ) |

protected

Build the bond models. This method is called from the finish method. It iterates over every Bond object that can be reached from the stored Atom objects and calls visualiseBond_(), which has to be overloaded in derived classes.

## clear()

virtual void BALL::VIEW::AtomBondModelBaseProcessor::clear | ( |  | ) |

virtual

Explicit default initialization. Reset the state of this AtomBondModelBaseProcessor:

- clear the used atoms
- clear the ModelProcessor Calls ModelProcessor::clear. Calls clearUsedAtoms_().

Reimplemented from BALL::VIEW::ModelProcessor.

Reimplemented in BALL::VIEW::AddBallAndStickModel, and BALL::VIEW::HBondModelProcessor.

## clearComposites()

virtual void BALL::VIEW::AtomBondModelBaseProcessor::clearComposites | ( |  | ) |

virtual

Needed in derived classes, which store references to the Composite instances they worked on. Here only needed for a common interface and therefore empty.

Reimplemented from BALL::VIEW::ModelProcessor.

## clearUsedAtoms_()

void BALL::VIEW::AtomBondModelBaseProcessor::clearUsedAtoms_ | ( |  | ) |

protected

Clear all used atoms.

## createGeometricObjects()

virtual bool BALL::VIEW::AtomBondModelBaseProcessor::createGeometricObjects | ( |  | ) |

virtual

Method to create geometric objects. This method is called in Representation::update() after all operator() was called for all Composites. To be overloaded in derived classes

Reimplemented from BALL::VIEW::ModelProcessor.

Reimplemented in BALL::VIEW::AddBallAndStickModel.

## dump()

virtual void BALL::VIEW::AtomBondModelBaseProcessor::dump | ( | std::ostream & | s = std::cout,
|  | Size | depth = 0 ) const

virtual

Internal value dump. Dump the current state to the output ostream s with dumping depth depth. Calls ModelProcessor::dump.

Parameters

  s | output stream where to output the state
  depth | the dumping depth

Reimplemented from BALL::VIEW::ModelProcessor.

Reimplemented in BALL::VIEW::AddBallAndStickModel, BALL::VIEW::AddLineModel, and BALL::VIEW::AddVanDerWaalsModel.

## getAtomList_()

std::list< const Atom * > & BALL::VIEW::AtomBondModelBaseProcessor::getAtomList_ | ( |  | ) |

protected

Mutable inspection of the list of used atoms.

## getAtomSet_()

HashSet< const Atom * > & BALL::VIEW::AtomBondModelBaseProcessor::getAtomSet_ | ( |  | ) |

protected

Mutable inspection of the hash set of used atoms.

## insertAtom_()

void BALL::VIEW::AtomBondModelBaseProcessor::insertAtom_ | ( | const Atom * | atom | ) |

protected

Insert an Atom into the used atoms structure. All the inserted atoms will be later processed to generate the graphical representation of the Bond objects that can be reached from each inserted atom.

Parameters

  atom | the Atom object to inserted

## operator()()

virtual Processor::Result BALL::VIEW::AtomBondModelBaseProcessor::operator() | ( | Composite & | composite | ) |

virtual

Operator method. This method iterates over each Composite object reachable in the Composite tree. If a Composite is of kind Moleculue and has aromatic rings, these rings are stored for later processing in the finish method.

Parameters

  composite | the Composite object that will be processed

Reimplemented from BALL::UnaryProcessor< Composite >.

Reimplemented in BALL::VIEW::AddBallAndStickModel, BALL::VIEW::AddLineModel, BALL::VIEW::AddVanDerWaalsModel, and BALL::VIEW::HBondModelProcessor.

## operator=()

const AtomBondModelBaseProcessor & BALL::VIEW::AtomBondModelBaseProcessor::operator= | ( | const AtomBondModelBaseProcessor & | processor | ) |

Assignment operator. Calls set.

## set()

void BALL::VIEW::AtomBondModelBaseProcessor::set | ( | const AtomBondModelBaseProcessor & | processor | ) |

Assignment. Calls clearUsedAtoms_(). Calls ModelProcessor::set.

## visualiseBond_()

virtual void BALL::VIEW::AtomBondModelBaseProcessor::visualiseBond_ | ( | const Bond & | bond | ) |

protected virtual

Reimplemented in BALL::VIEW::AddBallAndStickModel, and BALL::VIEW::AddLineModel.

## visualiseRings_()

virtual void BALL::VIEW::AtomBondModelBaseProcessor::visualiseRings_ | ( |  | ) |

inline protected virtual

Reimplemented in BALL::VIEW::AddBallAndStickModel.

Definition at line 157 of file atomBondModelBaseProcessor.h.

## Member Data Documentation

## ring_atoms_

HashSet<const Atom*> BALL::VIEW::AtomBondModelBaseProcessor::ring_atoms_

protected

Definition at line 160 of file atomBondModelBaseProcessor.h.

## rings_

vector<vector<Atom*> > BALL::VIEW::AtomBondModelBaseProcessor::rings_

protected

Definition at line 159 of file atomBondModelBaseProcessor.h.